--[[
file: main.lua -- Where all the magic really happens
by: Solsis00
for: ClickBoxHealer Unit Frames addition

This file contains all the core functions that do the real work, including all status changes post frame creation

**COMPLETE: Converted to local cbh table successfully.
]]--

local addon, cbh = ...




--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]
--[[												TARGET TABLE EVENTS]]
--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]

function cbh.TargetLoadSettings(x, addonid)
	-- if addonid == "CBHUnits" then
		cbh.defaults.TargetValues = {
			enabled = true,
			fx = 1520,
			fy = 900,
			fheight = 55,
			fwidth = 200,

			texture = 13,
			fontsize = 12,
			rolesize = 24,
			marksize = 38,

			namefontsize = 16,
			macros = true,
		}
		if not cbhTargetValues then
			cbhTargetValues = {}
			for k, v in pairs(cbh.defaults.TargetValues) do
				cbhTargetValues[k] = v
			end
		else
			for k, v in pairs(cbh.defaults.TargetValues) do
				if cbhTargetValues[k] == nil then
					cbhTargetValues[k] = v
				end
			end
		end
	-- end
end



--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]
--[[												TARGET FRAME SETUP]]
--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]
cbh.TargetTable = {}
cbh.TargetWindow = UI.CreateFrame("Frame", "TargetMainWindow", cbh.Context)
-- cbh.TargetWindow:SetSecureMode("restricted")
cbh.TargetWindowDrag = UI.CreateFrame("Texture", "TargetDrag", cbh.TargetWindow)
cbh.TargetClick = UI.CreateFrame("Frame", "TargetFrame", cbh.Context)
cbh.TargetClick:SetSecureMode("restricted")
cbh.TargetFrame = UI.CreateFrame("Texture", "TargetFrame", cbh.TargetWindow)
cbh.TargetHP = UI.CreateFrame("Frame", "TargetHP", cbh.TargetWindow)
cbh.TargetName = UI.CreateFrame("Text", "TargetFrame", cbh.TargetWindow)
cbh.TargetHealth = UI.CreateFrame("Text", "TargetHealth", cbh.TargetWindow)
cbh.TargetRole = UI.CreateFrame("Texture", "TargetRole", cbh.TargetWindow)
cbh.TargetRaidMark = UI.CreateFrame("Texture", "TargetRole", cbh.TargetWindow)
-- cbh.TargetTier = UI.CreateFrame("Texture", "TargetRole", cbh.TargetWindow)




function cbh.CreateTargetFrame()
	if cbhTargetValues.enabled then
		cbh.TargetWindow:SetPoint("TOPLEFT", cbh.Context, "TOPLEFT", cbhTargetValues.fx, cbhTargetValues.fy)
		cbh.TargetWindow:SetVisible(false)

		-- CREATE "DRAG ORB" FOR MOVING FRAME
		cbh.TargetWindowDrag:SetPoint("TOPRIGHT", cbh.TargetWindow, "TOPLEFT", 0, 0)
		cbh.TargetWindowDrag:SetTexture("Rift", "StarFlare_Orange.png.dds")
		cbh.TargetWindowDrag:SetLayer(9)
		cbh.TargetWindowDrag:SetWidth(48)
		cbh.TargetWindowDrag:SetHeight(48)
		cbh.TargetWindowDrag:SetVisible(false)

		-- ALLOWS DRAGGING OF FRAME AND REPOSITIONING WHEN FRAME ISN'T LOCKED
		cbh.TargetWindowDrag:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			self.windowdragActive = true
			local mouseStatus = Inspect.Mouse()
			self.oldx = mouseStatus.x - cbhTargetValues.fx
			self.oldy = mouseStatus.y - cbhTargetValues.fy
		end, "Event.UI.Input.Mouse.LeftDown")

		--CHANGE SAVED FRAMENUMBERIABLES WHEN MOUSE IS MOVED WHILE DRAGGING ACTIVE
		cbh.TargetWindowDrag:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			if self.windowdragActive == true then
				self.moved = true
				local mouseStatus = Inspect.Mouse()
				cbhTargetValues.fx = mouseStatus.x - self.oldx
				cbhTargetValues.fy = mouseStatus.y - self.oldy
				cbh.TargetWindow:SetPoint("TOPLEFT", cbh.Context, "TOPLEFT", cbhTargetValues.fx, cbhTargetValues.fy)
			end
		end, "Event.UI.Input.Mouse.Cursor.Move")

		-- ENDS DRAGGING WHEN LEFT CLICK RELEASED
		cbh.TargetWindowDrag:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			self.windowdragActive = false
		end, "Event.UI.Input.Mouse.LeftUp")

		cbh.TargetWindowDrag:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function(self, h)
			self.windowdragActive = false
		end, "Event.UI.Input.Mouse.Left.Upoutside")

		-- LOCKS FRAME IF RIGHT CLICKED
		cbh.TargetWindowDrag:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
			cbh.FrameLocked()
		end, "Event.UI.Input.Mouse.Right.Click")

		cbh.TargetClick:SetPoint("TOPLEFT", cbh.TargetWindow, "TOPLEFT", 0, 0)
		cbh.TargetClick:SetWidth(cbhTargetValues.fwidth)
		cbh.TargetClick:SetHeight(cbhTargetValues.fheight)
		cbh.TargetClick:SetBackgroundColor(0,0,0,0.05)

		cbh.TargetFrame:SetPoint("TOPLEFT", cbh.TargetWindow, "TOPLEFT", 0, 0)
		cbh.TargetFrame:SetTexture("ClickBoxHealer", "Textures/"..cbhTargetValues.texture)
		--cbh.TargetFrame:SetTexture("ClickBoxHealer", "Textures/health_"..cbhTargetValues.texture..".png")
		cbh.TargetFrame:SetWidth(cbhTargetValues.fwidth)
		cbh.TargetFrame:SetHeight(cbhTargetValues.fheight)
		--cbh.TargetFrame:SetBackgroundColor(0,0,0,1)
		--cbh.TargetFrame:SetAlpha(1)
		cbh.TargetFrame:SetLayer(0)

		cbh.TargetHP:SetPoint("TOPRIGHT", cbh.TargetFrame, "TOPRIGHT", 0, 0)
		cbh.TargetHP:SetWidth(0)
		cbh.TargetHP:SetHeight(cbhTargetValues.fheight)
		cbh.TargetHP:SetBackgroundColor(0,0,0,1)
		cbh.TargetHP:SetLayer(1)

		cbh.TargetName:SetPoint("CENTER", cbh.TargetFrame, "CENTER", 0, 0)
		cbh.TargetName:SetLayer(2)
		cbh.TargetName:SetFontSize(cbhTargetValues.namefontsize)
		cbh.TargetName:SetEffectGlow(cbh.NameGlowTable)

		cbh.TargetHealth:SetPoint("BOTTOMCENTER", cbh.TargetFrame, "BOTTOMCENTER", 0, 0)
		cbh.TargetHealth:SetLayer(2)
		cbh.TargetHealth:SetFontSize(cbhTargetValues.fontsize)
		cbh.TargetHealth:SetEffectGlow(cbh.NameGlowTable)

		cbh.TargetRole:SetPoint("TOPLEFT", cbh.TargetFrame, "TOPLEFT", 0, 0)
		cbh.TargetRole:SetLayer(2)
		cbh.TargetRole:SetWidth(cbhTargetValues.rolesize)
		cbh.TargetRole:SetHeight(cbhTargetValues.rolesize)

		cbh.TargetRaidMark:SetPoint("CENTER", cbh.TargetFrame, "TOPCENTER", 0, 0)
		cbh.TargetRaidMark:SetLayer(2)
		cbh.TargetRaidMark:SetVisible(false)
		cbh.TargetRaidMark:SetWidth(cbhTargetValues.marksize)
		cbh.TargetRaidMark:SetHeight(cbhTargetValues.marksize)

		-- cbh.TargetClick:EventAttach(Event.UI.Input.Mouse.Right.Down, function(self, h)
			-- if cbh.unitLookup("player.target") then cbh.ContextMenu("player.target") end
		-- end, "Event.UI.Input.Mouse.Right.Down")

		cbh.TargetFrame:EventAttach(Event.UI.Input.Mouse.Right.Down, function(self, h)
			cbh.ContextMenu("player.target")
		end, "Event.UI.Input.Mouse.Right.Down")

		cbh.targetframeloaded = true
	end
end


--[[ XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX ]]--
function cbh.TargetUnitChange(units)
	cbh.TargetWindow:SetVisible(false)
	cbh.UnitStatus["target"] = nil
	if units and cbhTargetValues.enabled then --and not cbh.UnitStatus[units].istarget then
		cbh.TargetWindow:SetVisible(true)
		cbh.GetTargetInfo(units)
	end
end

function cbh.GetTargetInfo(uid)
	local tid = cbh.unitDetail(uid)
	if tid then
		cbh.UnitStatus["target"] = {
			id = tid.id,
			name = tid.name,
			istarget = true,
			isfriendly = tid.friendly,

			level = tid.level,
			tier = tid.tier,
			role = tid.role,
			calling = tid.calling,
			raidmark = tid.mark,

			aggro = tid.aggro,
			offline = tid.offline,
			dead = nil,
			los = nil,	-- tid.blocked
			outofrange = nil,
			warfront = nil,

			xcoord = tid.coordX,
			ycoord = tid.coordY,
			health = tid.health,
			healthmax = tid.healthMax,
			healthcap = tid.healthCap,
			mana = tid.mana,
			manamax = tid.manaMax,

			haswhitedebuff = nil,
			whitedebuffqty = 0,
			poisonqty = 0,
			curseqty = 0,
			diseaseqty = 0,
			hasdebuffs = false,
			hasburnout = false,
		}

		cbh.nameCalc(tid.name, nil, "target")

		if tid.role then
			cbh.TargetRole:SetVisible(true)
			cbh.TargetRole:SetTexture("Rift", cbh.RoleImgs[tid.role])
		else cbh.TargetRole:SetVisible(false) end

		if tid.mark then
			cbh.TargetRaidMark:SetVisible(true)
			cbh.TargetRaidMark:SetTexture("Rift", cbh.RaidMarkerImages[tid.mark])
		else cbh.TargetRaidMark:SetVisible(false) end

		if tid.relation == "friendly" then
			if tid.calling and tid.player then
				for i = 1, 4 do
					if tid.calling == cbh.Calling[i] then
						cbh.TargetName:SetFontColor(cbhCallingColors[i].r, cbhCallingColors[i].g, cbhCallingColors[i].b, 1)
					end
				end
			else
				cbh.TargetName:SetFontColor(.1, .5, 1)
			end
		elseif tid.relation == "hostile" then
			cbh.TargetName:SetFontColor(.8, 0, 0)
		else
			cbh.TargetName:SetFontColor(.8, .8, 0)
		end

		local temptid = { [uid] = cbh.UnitStatus["target"].health }
		cbh.UpdateTargetHP(x, temptid)
	end
end


function cbh.UpdateTargetHP(x, units)
	if cbh.UnitStatus["target"] and units[cbh.UnitStatus["target"].id] then
		-- local thealth = units[cbh.UnitStatus["target"].id]
		cbh.UnitStatus["target"].health = units[cbh.UnitStatus["target"].id]
		-- for k, v in pairs(units) do
		-- if k == cbh.UnitStatus["target"].id then
			local healthcalc = (cbh.UnitStatus["target"].health / cbh.UnitStatus["target"].healthmax)
			local healthtick = (-healthcalc * cbhTargetValues.fwidth)
			if healthtick < cbhTargetValues.fwidth then healthtick = healthtick + cbhTargetValues.fwidth end
			cbh.TargetHP:SetWidth(healthtick)
			-- if cbhValues.healthgradient then
				if cbhValues.debuffcolorwhole == false or cbh.UnitStatus["target"].hasdebuffs == false then
					if healthcalc < .3 then
						cbh.TargetFrame:SetBackgroundColor(1, 0, 0, cbhCallingColors[7].a)
					elseif healthcalc < .65 then
						cbh.TargetFrame:SetBackgroundColor(1, 1, 0, cbhCallingColors[7].a)
					else cbh.TargetFrame:SetBackgroundColor(cbhCallingColors[7].r, cbhCallingColors[7].g, cbhCallingColors[7].b, cbhCallingColors[7].a) end
				end
			-- end
			-- if cbhValues.hidehealth == false then
				local health = 0
				local healthpercent = math.ceil(healthcalc * 100)
				if cbh.UnitStatus["target"].health > 1000000 then
					health = cbh.round((cbh.UnitStatus["target"].health/1000000), 1)
					health = tostring(health).."m"
					cbh.TargetHealth:SetText(health.."  "..healthpercent.."%")
				elseif cbh.UnitStatus["target"].health > 1000 then
					health = cbh.round((cbh.UnitStatus["target"].health/1000), 1)
					health = tostring(health).."k"
					cbh.TargetHealth:SetText(health.."  "..healthpercent.."%")
				elseif cbh.UnitStatus["target"].health <= 0 or math.ceil(healthcalc) == 0 then
					cbh.TargetHealth:SetText("DEAD")
					cbh.UnitStatus["target"].dead = true
				end
			-- end
		-- end
	-- end
	end
end


function cbh.UpdateTargetHPMax(hEvent, units)
	if cbh.UnitStatus["target"] and units[cbh.UnitStatus["target"].id] then
		local tvalue = units[cbh.UnitStatus["target"].id]
		cbh.UnitStatus["target"].healthmax = tvalue
		local tempid = {[cbh.UnitStatus["target"].id] = cbh.UnitStatus["target"].health}
		cbh.UpdateTargetHP(x, tempid)
	end
end


function cbh.UpdateTargetHPCap(bEvent, units)

end



function cbh.UpdateTargetMB(hEvent, units)

end


function cbh.UpdateTargetMBMax(hEvent, units)

end



function cbh.TargetMentoredUpdate(hEvent, units)
-- just send this back through the change target function
end



function cbh.TargetaggroUpdate(hEvent, units)

end



function cbh.TargetOnlineStatusUpdate(hEvent, units)

end



-- Triggered when absorption value on a unit changes
function cbh.TargetAbsorbUpdate(hEvents, units)

end



function cbh.TargetRaidMarkUpdate(hEvent, units)
	if cbh.UnitStatus["target"] and units[cbh.UnitStatus["target"].id] then
		local tvalue = units[cbh.UnitStatus["target"].id]
		cbh.TargetRaidMark:SetVisible(true)
		cbh.TargetRaidMark:SetTexture("Rift", cbh.RaidMarkerImages[tvalue])
	end
end



-- Updates group role changes based on current spec unless in a dungeon
function cbh.TargetRoleCheck(hEvent, units)

end



function cbh.TargetBuffAdding(hEvent, unit, buffs)

end


function cbh.TargetBuffRemoving(hEvent, unit, buffs)

end


function cbh.TargetHideOutofCombat(groupnum, oor)

end


function cbh.TargetUnitMouseOver(units)
	-- dump(units)
end





--[[
find:			(UnitStatus.*\])\[1\]
replace:	\1\.aggro
]]--




--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]
--[[												TARGET TABLE EVENTS]]
--[[<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>]]
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, cbh.TargetLoadSettings, "TargetLoadSettings")
Command.Event.Attach(Event.Addon.Startup.End, cbh.CreateTargetFrame, "CreateTargetFrame")


-- table.insert(Library.LibUnitChange.Register("mouseover"), {cbh.PTUnitMouseOver, "ClickBoxHealer", "cbhOnUnitMouseOver"}) -- create a mouseover event
table.insert(Library.LibUnitChange.Register("player.target"), {cbh.TargetUnitChange, "ClickBoxHealer", "TargetUnitChange"})
Command.Event.Attach(Event.Unit.Detail.Health, cbh.UpdateTargetHP, "UpdateTargetHP")
Command.Event.Attach(Event.Unit.Detail.HealthMax, cbh.UpdateTargetHPMax, "UpdateHP")
Command.Event.Attach(Event.Unit.Detail.Mark, cbh.TargetRaidMarkUpdate, "UpdateRaidMark")


